      Program RMO
     
      ! For velocity analysis by semblance
      ! on unmigrated CMP
      
      use sep
      use ooio
      use rmo_tools
      
      implicit none
      integer   :: it,ix,is,iz
      integer   :: nt,nx,ns,nz,full
      integer   :: izs,izmin,izmax
      integer	:: width
      integer	:: ismin,ismax
      real      :: ot,ox,os,oz
      real      :: dt,dx,ds,dz
      real      ::  t, x, s, z,dd
      real      ::  a, p, eta, pi=3.1415927
      real      :: nsum,dsum,eps,pow,cst=0
      real,allocatable,dimension(:,:) :: stack,stack2
      real,allocatable,dimension(:,:) :: d,m
      
      call sep_init()
      call from_history("n1",nt)
      call from_history("o1",ot)
      call from_history("d1",dt)
      call from_history("n2",nx)
      call from_history("o2",ox)
      call from_history("d2",dx)
      call from_param(  "ns",ns,100)
      call from_param(  "os",os,.95)
      call from_param("full",full,1)
      call from_param("dip",a,0.)
      call from_param("phi",p,0.)
      call from_param("width",width,6)
      call from_param("pow",pow,1.)
      call from_param("eps",eps,1.)
      
      allocate(     d(nt,nx))
      allocate(     m(nt,ns));m=0
      allocate(stack( nt,ns));stack=0
      allocate(stack2(nt,ns));stack2=0
      
      call sep_read(d)

      m   = 0  ; 
      a   =  a*pi/180 ; 
      p   =  p*pi/180 ; 
      eta = 45*pi/180 ; 
      nz  = nt ; oz  = ot ; dz  = dt
      ds  = .2/ns
      ds  = 2*(1.03-os)/ns
      write(0,*)'####ns,ds,os',ns,ds,os

      depth:do iz=13,nz-22 ; z =  oz+(iz-1)*dz
      
        izmin=iz-2*width/4
        izmax=iz+2*width/4
        if(izmin<1 )izmin=1
        if(izmax>nz)izmax=nz

        slowness:do is=1,ns ; s =  os+(is-1)*ds
      
          gamma:do ix=1,nx; x=(ox+(ix-1)*dx)*pi/180
            t  = t_rmo(s,z,a,eta,x,p,full)
            it = 1.5+(t-ot)/dt
            dd = lin_int(d(:,ix),t,nt,dt,ot)
            stack( iz,is) = stack( iz,is) + dd
            stack2(iz,is) = stack2(iz,is) + dd**2
          end do gamma
      
          do izs=izmin,izmax
          ! normalization constant
            cst = cst + stack2(izs,ix)
          ! semblance
            m(iz,is) = m(iz,is) + stack(izs,is)**2
          end do

        end do slowness                          
      end do depth
      
      cst = nx*cst+eps
      m = m**pow / cst
      
      call to_history("n1",nt)
      call to_history("d1",dt)
      call to_history("o1",ot)
      call to_history("n2",ns)
      call to_history("d2",ds)
      call to_history("o2",os)
      call sep_write(m)
      call sep_close()
      deallocate(d,m,stack,stack2)

      end program RMO
