      Program RMOa
     
      ! For velocity analysis by semblance
      ! on migrated CMP
      ! Dip given as a function of depth
      
      use sep
      use ooio
      use rmo_tools
      
      implicit none
      integer   :: ix,is,iz
      integer   :: nt,nx,ns,nz,full,nx_max
      integer   :: izs,izmin,izmax
      integer	:: width
      integer	:: ismin,ismax
      real      :: ot,ox,os,oz
      real      :: dt,dx,ds,dz
      real      ::  t, x, s, z,dd
      real      :: eta, pi=3.1415927
      real      :: nsum,dsum,eps,pow,cst=0
      real,allocatable,dimension(:,:) :: stack,stack2
      real,allocatable,dimension(:,:) :: d,m
      real,allocatable,dimension(:)   :: num,den
      real,allocatable,dimension(:)   :: dip,phi
      
      call sep_init()
      call from_history("n1",nt)
      call from_history("o1",ot)
      call from_history("d1",dt)
      call from_history("n2",nx)
      call from_history("o2",ox)
      call from_history("d2",dx)
      call from_param(  "ns",ns,110)
      call from_param(  "os",os,.97)
      call from_param(  "ds",ds,.001)
      call from_param("full",full,1)
      call from_param("eta",eta,45.)
      call from_param("width",width,4)
      call from_param("pow",pow,8.)
      call from_param("eps",eps,10000000000.)
      
      allocate(     d(nt,nx));d=0
      allocate(   dip(nt   ));dip=0
      allocate(   phi(nt   ));phi=0
      allocate(   num(nt   ));num=0
      allocate(   den(nt   ));den=0
      allocate(     m(nt,ns));m=0
      allocate(stack( nt,ns));stack=0
      allocate(stack2(nt,ns));stack2=0
      
      call sep_read(d)
      
      call sep_read(dip,'dip')
      call sep_read(phi,'phi')

      m   = 0
      dip = dip*pi/180
      phi = phi*pi/180
      eta = eta*pi/180
      nz  = nt ; oz  = ot ; dz  = dt

      slowness:do is=1,ns ; s = os+(is-1)*ds
        depth:do iz=int(nz*5/100+1),int(nz*95/100) ; z =  oz+(iz-1)*dz
     
! this is to ignore the zero traces at high angle which
! artificially  reduces the semblance at increasing depth
          !if(z>1000)then
          !  nx_max = (2800-z)/35/dx
          !else 
            nx_max=nx
          !end if
 
          gamma:do ix=1,nx_max; x=(ox+(ix-1)*dx)*pi/180
            t  = t_rmo(s,z,dip(iz),eta,x,phi(iz),full)
            dd = lin_int(d(:,ix),t,nt,dt,ot)
            stack( iz,is) = stack( iz,is) + dd
            stack2(iz,is) = stack2(iz,is) + dd**2
          end do gamma

        end do depth
      
        num=0
        den=0
        depth1:do iz=int(nz*10/100+1),int(nz*90/100)

          izmin=iz-width/2
          izmax=iz+width/2
          if(izmin<1 )izmin=1
          if(izmax>nz)izmax=nz

          do izs=izmin,izmax
            ! semblance
            num(iz) = num(iz) + stack(izs,is)**2
            ! normalization constant
            den(iz) = den(iz) + stack2(izs,is)
          end do

          m(iz,is) = (num(iz)/(nx*den(iz)+eps))

        end do depth1

      end do slowness                          
     
      call to_history("n1",nt)
      call to_history("d1",dt)
      call to_history("o1",ot)
      call to_history("n2",ns)
      call to_history("d2",ds)
      call to_history("o2",os)
      call sep_write(m)
      call sep_close()
      deallocate(d,m,stack,stack2,dip,phi,num,den)

      end program RMOa
